﻿
(function () {

    var args, clientArgs;
    setTimeout(function () { ej.isOnWebForms = true; }, 1000);
    ej.raiseWebFormsServerEvents = function (eventName, eventProp, clientProp) {
        if (eventProp.model.serverEvents.indexOf(eventName) != -1) {
            args = eventProp, clientArgs = ignoreDOMElement(clientProp);
            setTimeout(function () {
                try {
                    var modelStr = JSON.stringify({ type: args.originalEventType, args: clientArgs });
                    __doPostBack(args.model.uniqueId, modelStr);
                }
                catch (e) { }
            }, 0);
        }
    }
    function ignoreDOMElement(args) {
        if (!args) return null;
        for (var name in args) {
            var ele = args[name];
            if ($.isPlainObject(ele)) ignoreDOMElement(ele);
            else if (isDOMObj(ele) || (ele && typeof ele.preventDefault == "function"))
                delete args[name];
        }
        return args;
    }
    function isDOMObj(o) {
        return o instanceof $ || (o && o.nodeType && o.nodeType == 1);
    }

})();

function EJ_ClientSideOnPostBack() {
    clearPostBackData();
    var $form = typeof theForm == "undefined" ? $("body form") : $(theForm);
    if (!$form.length) return;
    $form.append(getPostBackData());
    addPostBackHandler();
}

function getPostBackData() {
    var controls = $("body .e-js");
    var div = $(document.createElement("div"));
    div.attr("id", "ej-hidden-model-container");
    for (var i = 0; i < controls.length; i++) {
        var widgets = $(controls[i]).data("ejWidgets");
        if (!widgets) continue;
        for (var j = 0; j < widgets.length; j++) {
            var that = $(controls[i]).data(widgets[j]);
            if (!that || !that.model.clientId) continue;
            var hidden = $(document.createElement("input")).attr({
                "type": "hidden",
                "id": that.model.clientId + "_hidden_model",
                "name": that.model.clientId + "_hidden_model"
            }).val(JSON.stringify(includeRequiredProp(that)));
            div.append(hidden);
        }
    }
    return div;
}

function includeRequiredProp(that) {
    var propArray = that._includeOnViewstate || [], model = {};
    for (var n = 0; n < propArray.length; n++)
        model[propArray[n]] = ej.util.getObject(propArray[n], that.model);
    return model;
}

function clearPostBackData() {
    removePostBackHandler();
    $("#ej-hidden-model-container").remove();
}

function addPostBackHandler() {
    if (typeof Sys != "undefined")
        Sys.WebForms.PageRequestManager.getInstance().add_endRequest(clearPostBackData);
}
function removePostBackHandler() {
    if (typeof Sys != "undefined")
        Sys.WebForms.PageRequestManager.getInstance().remove_endRequest(clearPostBackData);
}