﻿(function () {
    setViewstate(ej.Accordion, ["cssClass", "enabled", "enableRTL", "selectedItems", "selectedItemIndex"]);
    setViewstate(ej.Autocomplete, ["cssClass", "enabled", "enableRTL", "readOnly", "value"]);
    setViewstate(ej.Button, ["enabled", "cssClass", "enableRTL"]);
    setViewstate(ej.Captcha, ["characterSet", "maximumLength", "caseSensitive", "autoValidate", "successMessage", "errorMessage", "encryptedCode", "isValid", "enableAudio", "enableRefreshImage", "enableRTL", "audioUrl"]);
    setViewstate(ej.CheckBox, ["checked", "enabled", "cssClass", "enableRTL"]);
    setViewstate(ej.ColorPicker, ["value", "cssClass", "enabled", "showRecentColors", "opacityValue", "toolIcon", "columns", "palette", "modelType"]);
    setViewstate(ej.CurrencyTextbox, ["cssClass", "locale", "enabled", "enableRTL", "readOnly", "value"]);
    setViewstate(ej.DatePicker, ["selectedDate", "dateFormat", "minDate", "maxDate", "locale", "enabled", "readOnly", "cssClass", "enableRTL"]);
    setViewstate(ej.DateTimePicker, ["value", "minDateTime", "maxDateTime", "locale", "enabled", "readOnly", "cssClass", "enableRTL"]);
    setViewstate(ej.DropDownList, ["value", "text", "enabled", "readOnly", "cssClass", "enableRTL", "selectedItems", "selectedItemIndex"]);
    setViewstate(ej.MaskEdit, ["value", "maskFormat", "inputMode", "enabled", "readOnly", "cssClass" ]);
    setViewstate(ej.Menu, ["animationType", "enabled", "cssClass", "enableRTL", "orientation"]);
    setViewstate(ej.NumericTextbox, ["cssClass", "locale", "enabled", "enableRTL", "readOnly", "value"]);
    setViewstate(ej.PercentageTextbox, ["cssClass", "locale", "enabled", "enableRTL", "readOnly", "value"]);
    setViewstate(ej.ProgressBar, ["value", "text", "percentage", "minValue", "maxValue", "enabled", "cssClass", "enableRTL"]);
    setViewstate(ej.RadioButton, ["checked", "enabled", "cssClass", "enableRTL"]);
    setViewstate(ej.Rating, ["value", "minValue", "maxValue", "readOnly", "cssClass"]);
    setViewstate(ej.RTE, ["cssClass", "locale", "enabled", "enableRTL", "value"]);
    setViewstate(ej.Slider, ["value", "values", "minValue", "maxValue", "incrementStep", "readOnly", "enabled", "enableRTL", "sliderType", "cssClass"]);
    setViewstate(ej.SplitButton, ["text", "cssClass", "enableRTL", "enabled"]);
    setViewstate(ej.Tab, ["selectedItemIndex", "enabled", "cssClass", "enableRTL"]);
    setViewstate(ej.Ribbon,["selectedItemIndex"]);
    setViewstate(ej.ListBox, ["selectedItemIndex", "selectedItemlist", "checkedItemlist"]);
    setViewstate(ej.TagCloud, ["enableRTL", "cssClass", "titleText", "titleImage", "format"]);
    setViewstate(ej.TimePicker, ["value", "minTime", "maxTime", "locale", "enabled", "readOnly", "cssClass", "enableRTL"]);
    setViewstate(ej.ToggleButton, ["enabled", "cssClass", "enableRTL", "toggleState", "activePrefixIcon",
                                            "activeSuffixIcon", "activeText", "defaultText", "defaultPrefixIcon", "defaultSuffixIcon"]);
    setViewstate(ej.Toolbar, ["enabled", "cssClass", "enableRTL", "orientation", "hide"]);
    setViewstate(ej.TreeView, ["cssClass", "enabled", "enableRTL", "expandedNodes", "checkedNodes"]);
    setViewstate(ej.Uploadbox, ["enabled", "multipleFilesSelection", "enableRTL", "cssClass", "showFileDetails"]);
    setViewstate(ej.PivotGrid, ["currentReport"]);
    setViewstate(ej.Schedule, ["currentDate", "currentView", "endHour", "startHour"]);
    setViewstate(ej.Grid, ["allowFiltering", "allowGrouping", "allowKeyboardNavigation", "allowMultiSorting", "allowPaging", "allowReordering","allowTextWrap","allowCellMerging",
                                             "allowResizing", "allowScrolling", "allowSearching", "allowSelection", "allowSorting", "showSummary",
                                             "cssClass", "detailsTemplate", "enableAltRow", "enableHeaderHover", "enablePersistence", "enableRTL", "enableRowHover", "locale",
                                             "query", "rowTemplate", "selectedRowIndex", "selectionType", "editSettings", "filterSettings", "groupSettings", "pageSettings",
                                             "scrollSettings", "sortSettings", "toolbarSettings","columns"]);
    if (ej.olap)
        setViewstate(ej.olap.OlapChart, ["currentReport"]);
    if (ej.datavisualization) {
        setViewstate(ej.datavisualization.Chart, ["series"]);
        setViewstate(ej.datavisualization.Map, ["enablePan", "enableAnimation", "enableResize"]);
        setViewstate(ej.datavisualization.TreeMap, ["highlightOnSelection", "enableResize"]);
        setViewstate(ej.datavisualization.CircularGauge, ["scales"]);
        setViewstate(ej.datavisualization.LinearGauge, ["scales"]);
        setViewstate(ej.datavisualization.Diagram, ["nodes", "connectors", "width", "height", "labels"]);
        
    }
})();

function setViewstate( namespace, viewstateData) {
    if (namespace)
        namespace.prototype._includeOnViewstate = viewstateData;
}
