﻿(function ($, ej, undefined) {
	ej.scheduleFeatures = ej.scheduleFeatures || {};

	var horizontalHeaderTemplate = function () {
	    this._horiDateHeader = ("{{if multiRes == true}}<td class = 'e-horizontalheader'><div class='e-horizontalresheader'>RESOURCES</div></td>{{else}}<td></td>{{/if}}" +
                                "<td class='e-horizontaldaterender' style='height:100%;'><div class='e-horizontaltimecells' style='height:{{:height}}px;'>" +
                                "<div class='e-headerdays' style='position:absolute;'>" +
                                "<table class ='e-table' cellpadding='0px' cellspacing='0px' style='width:100%;border-collapse:separate;'><tbody>{{if view !== 'month'}}" +
                                "<tr style='width:100%;'> <td>{{if view === 'day'}}<table style='width:100%;'>{{else}}<table cellspacing='0px'>{{/if}}<tbody><tr> {{for cols ~headercellWidth = headercellWidth}}<td class='e-headercells {{:cellToday}} e-horizontalheadertddate'><div class='{{:currentDateClass}} e-horizontalheaderdiv'>{{:currentDay}}</div></td>{{/for}} </tr></tbody></table></td> </tr>" +
                                "<tr style='width:100%;position:absolute;'> <td><table class ='e-horizontaltabletimecell' cellspacing='0px' style='border-collapse:collapse;'><tbody><tr> {{for timeTdCount }}{{for ~name=time ~dayend=timecellclass}}<td class='e-horizontaltimetd {{:~dayend}}'><div style='width:{{:cellWidth}}'><span class ='e-horizontaltimespan'>{{:~name.slice(0,2)}}</span><div class ='e-horizontaltimespandiv'>{{:~name.slice(3,5)}}</div></div></td><td class='e-horizontalalternatetd'><div style='width:{{:cellWidth}}'></div></td>{{/for}}{{/for}}  </tr></tbody></table></td> </tr>" +
                                "{{/if}}" +
                                "{{if view == 'month'}}<tr>{{for cols}}<td class='e-headercells e-horizontmonthheaderdatetd {{:cellToday}}'><div class='e-dateheadercell e-horizontmonthdatealign'>{{:currentDate}}</div></td>{{/for}}</tr>" +
                                "<tr>{{for cols}}<td class ='e-horizontmonthheaderdaytd'><div class='e-dateheadercell e-horizontmonthdatealign' style='width:{{:cellWidth}}'>{{:currentDay}}</div></td>{{/for}}</tr>" +
                                "{{/if}}</tbody></table></div></div></td>");
	    return this._horiDateHeader;
	};

	var horizontalResourceHeaderTemplate = function () {
	    this._horizontalResHeader = ("<div class ='e-horizontresdiv'><div class='e-horires' style='height:100%'><table class='e-table e-resourceheadertable' height='100%' width='100%' cellpadding='0px' cellspacing='0px'>" +
            "<tbody>{{for trs}}<tr>{{for ~resname=name ~marginleft=marginleft }}{{if classname == 'e-parentnode'}}<td class='{{:classname}}' style='width:25px;height:{{:cellHeight}}'></td>{{else}}<td style='width:25px;height:{{:cellHeight}}'></td>{{/if}}<td class='{{:classname}}' style='vertical-align:middle;height:{{:cellHeight}}'>" +
            "<div style='text-align:left;margin-left:{{:~marginleft}};'>{{if userResTemplId == true}}{{:userResHeader}}{{else}}{{:~resname}}{{/if}}</div>" +
            "</td>{{if classname == 'e-parentnode'}}<td id={{:idnum}} class='{{:classname}} {{:classname}}category e-resourceicon e-resourcecollapse' style='width:25px;vertical-align:middle;height:{{:cellHeight}}'></td>{{else}}<td class='{{:classname}} {{:classname}}category' style='width:25px;height:{{:cellHeight}}'></td>{{/if}}{{/for}}</tr>{{/for}}</tbody></table></div></div><div class='e-resfootertr' style='height:18px;'></div>");
	    return this._horizontalResHeader;
	};



	var horizontalCellsTemplate = function () {
	    this._cellsTemplate = ("<table class='e-table e-workcellstab' height='100%' cellpadding='0px' cellspacing='0px'>" +
        "<tbody>{{for cellrows ~cols=cols ~view=view ~classname=classname ~tdWidth=tdWidth}}" +
        "{{if classname == 'e-parentnode'}} <tr style='width:100%'>{{for ~cols ~tdWidth=tdWidth}}{{if #index % 24 == 0 && #index != 0 && ~view !== 'month' }}<td class='e-resourceheadercells e-workcells e-parentworkcell e-dayend' style='width:{{:cellWidth}};height:{{:cellHeight}}'>{{else}}<td class='e-resourceheadercells e-workcells e-parentworkcell' style='width:{{:cellWidth}};height:{{:cellHeight}}'>{{/if}}<div class='e-appointwrapper'></div></td>{{if ~view !== 'month'}}<td class='e-resourceheadercells e-workcells e-parentworkcell e-alternateworkcell' style='width:{{:cellWidth}};height:{{:cellHeight}}'><div class='e-appointwrapper'></div></td>{{/if}}{{/for}}</tr>" +
        "{{else}}<tr style='width:100%'>{{for ~cols ~tdWidth=tdWidth}}{{if #index % 24 == 0 && #index != 0 && ~view !== 'month' }}<td class='e-workcells e-childworkcell e-dayend' style='width:{{:cellWidth}};height:{{:cellHeight}}'>{{else}}<td class='e-workcells e-childworkcell' style='width:{{:cellWidth}};height:{{:cellHeight}}'>{{/if}}<div class='e-appointwrapper'></div></td>{{if ~view !== 'month'}}<td class='e-workcells e-childworkcell e-alternateworkcell' style='width:{{:cellWidth}};height:{{:cellHeight}}'><div class='e-appointwrapper'></div></td>{{/if}}{{/for}}" +
        "</tr>{{/if}}" +
        "{{/for}}</tbody></table>");
	    return this._cellsTemplate;
	};

	ej.scheduleFeatures.horizontal = {

	    _renderHorizontalTemplates: function () {
	        this.horizontalHeader = $.templates(this._createTemplate(horizontalHeaderTemplate(), "_HorizontalHeader"));
	        this.cellTemplate = $.templates(this._createTemplate(horizontalCellsTemplate(), "_HorizontalCells"));
	        this.horizontalResHeader = $.templates(this._createTemplate(horizontalResourceHeaderTemplate(), "_HorizontalResources"));
	    },

	    _horizontalViewNavigation: function (e) {
            if (e.type == "click") {
                if (this.currentView() === "week" || this.currentView() === "workweek" || (this.currentView() === "customview" && this._renderDays <= 7)) {
	                this.element.find(".e-headercells").children().removeClass("e-activeview");
	               
	                var currentDateIndex = e.currentTarget.cellIndex;

	                var navidate = this._getRenderDates()[currentDateIndex];
	                if (this.model.minDate <= navidate && this.model.maxDate >= navidate) {
	                    $(e.currentTarget).children().addClass("e-activeview");
	                    this.currentDate(navidate);
	                }
	                else { return false; }
                    if (this.model.highlightBusinessHours == true && !ej.isNullOrUndefined(this.model.businessStartHour))
	                    this._businessHourScroller();
	                else {
	                    var cellOffsetLeft = this.element.find(".e-workcells")[currentDateIndex * 48].offsetLeft;
	                    $(this.element.find(".e-horizontaltimecells").find("table tr")[2]).css("left", (-cellOffsetLeft) + "px");
	                    $('div#' + this._id + "_scroller").ejScroller({ scrollLeft: cellOffsetLeft });
	                }
 	            
	            }
                else if (this.currentView() == "month" || (this._isCustomView())) {
	                var currentDateIndex = e.currentTarget.cellIndex;
	                if (this.model.views.indexOf("Day") == -1) return false;

	                var navidate = this.monthDays[currentDateIndex];
	                if (this.model.minDate <= navidate && this.model.maxDate >= navidate) {
	                    this.currentDate(navidate);
	                }
	                else { return false; }
	                newView = "day";
	                this._navView = true;
	                this._viewChange(e,this.currentView(), newView);
	            }
	        }
	        else if (e.type == "dblclick") {
	            if (this.currentView() === "week" || this.currentView() === "workweek" || (this.currentView() === "customview" && this._renderDays <= 7)) {
				var _target = $(e.target);
	                var dayTarget = _target.hasClass("e-headercells") ? _target : _target.parent().hasClass("e-headercells") ? _target.parent() : _target.parent().parent();
	                if (this.model.views.indexOf("Day") == -1 || !dayTarget.hasClass("e-headercells")) return false;

	                var navidate = this._getRenderDates()[dayTarget.index()];
	                if (this.model.minDate <= navidate && this.model.maxDate >= navidate) {
	                    this.currentDate(navidate);
	                }
	                else { return false; }
	                newView = "day";
	                this._navView = true;
	                this._viewChange(e, this.currentView(), newView);
	            }
	        }

	    },

	    _renderHorizontalHeaderDays: function (localizeDays) {
	        if (this.currentView() !== "month" && !(this._isCustomView())) {
	            var curday, temp;
	            for (var i = 0; i < this._dateRender.length; i++) {
	                curday = (this.currentView() === "day") ? (ej.isNullOrUndefined(this.model.resources) && ej.isNullOrUndefined(this.model.group)) ? localizeDays.calendar.days.names[new Date(this._dateRender[i]).getDay()] : localizeDays.calendar.days.names[new Date(this._dateRender[i]).getDay()].slice(0, 3) : localizeDays.calendar.days.names[new Date(this._dateRender[i]).getDay()].slice(0, 3);
	                temp = this.currentView() === "day" ? (ej.isNullOrUndefined(this.model.resources) && ej.isNullOrUndefined(this.model.group)) ? curday + " " + Globalize.format(new Date(this._dateRender[i]), "dd MMMM yyyy") : curday + " " + Globalize.format(new Date(this._dateRender[i]), "dd MMM yy") : curday + " " + new Date(this._dateRender[i]).getDate();
	                $(this.element.find(".e-headercells")[i]).find("div")[0].innerHTML = temp;
	            }
	        }
	    },

	    _horizontalScroll: function (e, proxy) {
	        if (proxy.currentView() == "week" || proxy.currentView() == "workweek" || (this.currentView() === "customview" && this._renderDays <= 7)) {
	            var currentDateIndex = $(proxy.element.find(".e-headercells").find(".e-activeview").parent()).index();
	            var index = Math.floor((e.scrollLeft / (proxy.element.find(".e-workcells").width() + 1)) / 48);
	            if (currentDateIndex !== index)
	                proxy.element.find(".e-headercells").children().removeClass("e-activeview");
	            $(proxy.element.find(".e-headercells")[index]).children().addClass("e-activeview");
	        }
	    },

	    _getHorizontalheaderCellCount: function (weekcols) {
	        var cols = [];
	        for (var i = 0; i < this._dateRender.length; i++) {
	            curday = (this.currentView() === "month" || this.currentView() === "day" || (this._isCustomView())) ? (ej.isNullOrUndefined(this.model.resources) && ej.isNullOrUndefined(this.model.group)) ? weekcols.calendar.days.names[new Date(this._dateRender[i]).getDay()] : weekcols.calendar.days.names[new Date(this._dateRender[i]).getDay()].slice(0, 3) : weekcols.calendar.days.names[new Date(this._dateRender[i]).getDay()].slice(0, 3);
	            var headerCellClass = (Globalize.format(new Date(this._dateRender[i]), this._pattern.d) === Globalize.format(new Date(), this._pattern.d)) ? "e-headerToday" : "";
	            temp = this.currentView() === "month" || (this._isCustomView()) ? { currentDay: curday, currentDateClass: "", cellToday: headerCellClass, cellWidth: this.model.cellWidth } : this.currentView() === "day" ? (ej.isNullOrUndefined(this.model.resources) && ej.isNullOrUndefined(this.model.group)) ? { currentDay: curday + " " + Globalize.format(new Date(this._dateRender[i]), "dd MMMM yyyy"), currentDateClass: "", cellToday: headerCellClass, cellWidth: this.model.cellWidth } : { currentDay: curday + " " + Globalize.format(new Date(this._dateRender[i]), "dd MMM yy"), currentDateClass: "", cellToday: headerCellClass, cellWidth: this.model.cellWidth } : { currentDay: curday + " " + new Date(this._dateRender[i]).getDate(), currentDateClass: new Date(this._dateRender[i]).getDate() === new Date(this.currentDate()).getDate() ? "e-activeview" : "", cellToday: headerCellClass, cellWidth: this.model.cellWidth };
	            cols.push(temp);
	        }
	        return cols;
	    },

	    _getHoriStartEndTime: function (localizeAmPm) {
	        var startendTimes = [];
	        var daysCount = this.currentView() == "week" ? 7 : this.currentView() == "day" ? 1 : (this.currentView() === "customview" && this._renderDays <= 7) ? this._dateRender.length : 5;
	        for (var day = 0; day < daysCount; day++) {
	            for (var i = this.model.startHour; i < this.model.endHour; i++) { // * 2
	                if (this._timeMode === "12") {
	                    timelist = ((i === this.model.startHour || i === 12) && (localizeAmPm.AM && localizeAmPm.PM)) ? Globalize.format(new Date(new Date().setHours(i)), "hh tt") : Globalize.format(new Date(new Date().setHours(i)), "hh 00");
	                    startendTimes.push({ time: timelist, id: i, timecellclass: ((i % 48) == 0 && day != 0) ? "e-dayend" : "", cellWidth: (!this.model.cellWidth) ? "30px" : this.model.cellWidth, cellHeight: this.model.cellHeight });
	                }
	                else
	                    startendTimes.push({ time: (i <= 9 ? "0" + i : i) + " 00", timecellclass: ((i % 48) == 0 && day != 0) ? "e-dayend" : "", cellWidth: (!this.model.cellWidth) ? "30px" : this.model.cellWidth, cellHeight: this.model.cellHeight });
	            }
	        }
	        return startendTimes;
	    },

	    _getHorizontalDayAppointments: function (appointmentsList, dateCount, day, res) {
	        for (var app = 0; app < appointmentsList.length; app++) {
	            if (!ej.isNullOrUndefined(this.model.group) && ej.scheduleFeatures.resources) {
	                if (Globalize.format(new Date(dateCount[day]), "yyyy/MM/dd") == Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["startTime"]]), "yyyy/MM/dd") &&
                        Globalize.format(new Date(dateCount[day]), "yyyy/MM/dd") <= Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["endTime"]]), "yyyy/MM/dd") &&
                        (appointmentsList[app][this.model.appointmentSettings.resourceFields.toString().split(',')[this.model.resources.length - 1]] == this.res1[res].id) &&
                        Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["startTime"]]), "yyyy/MM/dd") <= Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["endTime"]]), "yyyy/MM/dd"))
	                    this._appList.push(appointmentsList[app]);
	            }
	            else {
	                if (Globalize.format(new Date(dateCount[day]), "yyyy/MM/dd") == Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["startTime"]]), "yyyy/MM/dd") &&
                        Globalize.format(new Date(dateCount[day]), "yyyy/MM/dd") <= Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["endTime"]]), "yyyy/MM/dd") &&
                        Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["startTime"]]),"yyyy/MM/dd") <= Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["endTime"]]), "yyyy/MM/dd"))
	                    this._appList.push(appointmentsList[app]);
	            }
	        }

	    },

	    _renderHorizontalApp: function (rStartTime, rEndTime, record, day, cellHeight, timeScaleRowCount, startHour, endHour) {
	        var headerCell = this.element.find(".e-workcellstab tr");
	        var newResCollection = this._getResourceCollection();
	        var appHeight, appWidth, topPosition, leftPosition, bottomPosition;
	        if (rStartTime <= rEndTime) {
	            var startTime = ((new Date(rStartTime).getHours()) < startHour) ? (new Date(rStartTime).getHours() + (-new Date(rStartTime).getHours()) + (-new Date(rStartTime).getMinutes())) : (new Date(rStartTime).getHours() + (-startHour));
	            var endTime = ((new Date(rEndTime).getHours()) > endHour) ? (new Date(rEndTime).getHours() + (-new Date(rEndTime).getHours() + (endHour - startHour)) + (-new Date(rEndTime).getMinutes())) : (new Date(rEndTime).getHours() + (-startHour));
	            endTime = (new Date(rEndTime).getHours() == endHour) ? (new Date(endTime).getMinutes() + (-new Date(rEndTime).getMinutes())) : endTime;
	            appHeight = 20;
	            topPosition = 0;
	            var level = 0;
	            if (this.model.startHour <= new Date(rStartTime).getHours()) {

	                var groupIndex = (!ej.isNullOrUndefined(this.model.group) && this.model.group.resources.length > 1) ? this._findResourceIndex(newResCollection[0].dataSource, "id", record[this.model.appointmentSettings.resourceFields.toString().split(',')[this.model.resources.length - 2]]) + 1 : 0;
	                var resValue = (!ej.isNullOrUndefined(this.model.group) && !ej.isNullOrUndefined(this.model.resources)) ? this._findResourceIndex(this.level_Resources, "id", record[this.model.appointmentSettings.resourceFields.toString().split(',')[this.model.resources.length - 1]]) + 1 : 1;

	                var overlapList = (ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.resources) && !ej.isNullOrUndefined(this.model.group)) ? this._overlapApp(record[this.model.appointmentSettings["id"]], record[this.model.appointmentSettings["startTime"]], record[this.model.appointmentSettings["endTime"]], record[this.model.appointmentSettings.resourceFields.toString().split(',')[this.model.resources.length - 1]]) : this._overlapApp(record[this.model.appointmentSettings["id"]], record[this.model.appointmentSettings["startTime"]], record[this.model.appointmentSettings["endTime"]], null);
	                var proxy = this;

	                var level = (ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.resources) && !ej.isNullOrUndefined(this.model.group)) ? this._getOverlapCount(record, day, this._dateRender, record[this.model.appointmentSettings.resourceFields.toString().split(',')[this.model.resources.length - 1]]) : this._getOverlapCount(record, day, this._dateRender, null);
	                topPosition = (topPosition + (level * appHeight));

	                if (record[this.model.appointmentSettings["allDay"]]) {
	                    diffTime = new Date(Globalize.format(new Date(rEndTime), this._pattern.d)) - new Date(Globalize.format(new Date(rStartTime), this._pattern.d)); // recordEnd.AddDays(1).Subtract(recordStart);
	                    var diffDays = Math.round(diffTime / 86400000) + 1;
	                    if (diffDays > this._dateRender.length) // if no of days excceeded the renderdates
	                        diffDays = new Date(this._dateRender[this._dateRender.length - 1]).getDay() + 1 - new Date(rStartTime).getDay();
	                    diffMinutes = (diffDays * 24 * 60); // minutes
	                    cellIndex = ((this.model.endHour - this.model.startHour) * timeScaleRowCount) * day;
	                    appWidth = ((this.element.find(".e-workcells").outerWidth() / (30)) * diffMinutes);
	                    leftPosition = "0";
	                }
	                else if (new Date(Globalize.format(new Date(record[this.model.appointmentSettings["startTime"]]), this._pattern.d)) < new Date(Globalize.format(new Date(record[this.model.appointmentSettings["endTime"]]), this._pattern.d))) {
	                    diffTime = new Date(Globalize.format(new Date(rEndTime), this._pattern.d)) - new Date(Globalize.format(new Date(rStartTime), this._pattern.d));
	                    var diffDays = Math.round(diffTime / 86400000);
	                    diffMinutes = (((diffDays) * 24 * 60) - (new Date(rStartTime).getHours() * 60) + new Date(rStartTime).getMinutes()) + ((new Date(rEndTime).getHours() * 60) + new Date(rEndTime).getMinutes());
	                    cellIndex = (((this.model.endHour - this.model.startHour) * timeScaleRowCount) * day) + (startTime * timeScaleRowCount);
	                    appWidth = ((this.element.find(".e-workcells").outerWidth() / (30)) * diffMinutes);
	                    if (diffDays > this._dateRender.length) // if no of days excceeded the renderdates
	                    {
	                        diffDays = new Date(this._dateRender[this._dateRender.length - 1]).getDay() + 1 - new Date(rStartTime).getDay();
	                        diffMinutes = ((diffDays) * 24 * 60); // minutes
	                        appWidth = ((this.element.find(".e-workcells").outerWidth() / (30)) * diffMinutes) - (cellIndex * 25) + 10;
	                    }
	                    leftPosition = (parseFloat((new Date(rStartTime).getMinutes())) * (this.element.find(".e-workcells")[0].offsetWidth) * timeScaleRowCount / 60);

	                }
	                else {
	                    leftPosition = (parseFloat((new Date(rStartTime).getMinutes())) * (this.element.find(".e-workcells")[0].offsetWidth) * timeScaleRowCount / 60);
	                    diffInMinutes = ((new Date(rEndTime).getHours() * 60) + new Date(rEndTime).getMinutes()) - ((new Date(rStartTime).getHours() * 60) + new Date(rStartTime).getMinutes());
	                    appWidth = ((this.element.find(".e-workcells").width() / 30) * diffInMinutes) + ((new Date(rEndTime).getHours() - new Date(rStartTime).getHours()) * timeScaleRowCount) - 2;
	                    cellIndex = (((this.model.endHour - this.model.startHour) * timeScaleRowCount) * day) + (startTime * timeScaleRowCount);
	                }
	                var colorAppointment = this._appointmentColor(record);
	                //

	                //
	                //var minDate = new Date(this._dateRender[this._dateRender.length - 1]);
	                //var maxDate = new Date(this._dateRender[0]);
	                //for (var i = 0; i < overlapList.length; i++) {
	                //    var date = new Date(overlapList[i][proxy.model.appointmentSettings["startTime"]]);
	                //    if (date < minDate)
	                //        minDate = date;
	                //    var date1 = new Date(overlapList[i][proxy.model.appointmentSettings["endTime"]]);
	                //    if (date1 > maxDate)
	                //        maxDate = date1;
	                //}
	                //if (overlapList.length > 0) {
	                //    if (this._categorybar) {
	                //        this._renderCategory(headerCell, groupIndex, record, cellHeight, minDate, maxDate, appointColor, timeScaleRowCount, day, startTime, endTime);
	                //        this._categorybar = false;
	                //    }
	                //    else {
	                //        if (new Date(record[this.model.appointmentSettings["startTime"]]) >= new Date(maxDate) && record[this.model.appointmentSettings["endTime"]] <= minDate)
	                //            this._renderCategory(headerCell, groupIndex, record, cellHeight, minDate, maxDate, appointColor, timeScaleRowCount, day, startTime, endTime);
	                //    }
	                //}
	                //else {
	                //    this._renderCategory(headerCell, groupIndex, record, cellHeight, new Date(rStartTime), new Date(rEndTime), appointColor, timeScaleRowCount, day, startTime, endTime);
	                //}

	                //

	                //
	                if ((topPosition + appHeight) < cellHeight) {
	                    //user-defined Template data rendering
	                    var userAppTemplId = (this.model.appointmentTemplateId) ? true : false;
	                    var userTempHtml = this._getUserAppointmentTemplate(record);
	                    var startTimeDisp = this._timeMode == "12" ? Globalize.format(new Date(record[this.model.appointmentSettings["startTime"]]), this._pattern.t) : Globalize.format(new Date(record[this.model.appointmentSettings["startTime"]]), "HH:mm");
	                    var endTimeDisp = this._timeMode == "12" ? Globalize.format(new Date(record[this.model.appointmentSettings["endTime"]]), this._pattern.t) : Globalize.format(new Date(record[this.model.appointmentSettings["endTime"]]), "HH:mm");

	                    //   var category = "e-" + record[this.model.appointmentSettings["categorize"]];
	                    var timeCellhtml = this.appTemplate.render({ id: record[this.model.appointmentSettings["id"]], appHeight: appHeight, rtl: this.model.enableRTL, subject: record[this.model.appointmentSettings["subject"]], startTime: startTimeDisp, endTime: endTimeDisp, left: leftPosition + "px", top: topPosition, appWidth: appWidth + "px", userAppTemplId: userAppTemplId, userTemplate: userTempHtml, appClass: "e-appointment", appointData: colorAppointment.appointColor.appointData, appointCustomcss: colorAppointment.appointColor.appointCustomcss, appointtextcolor: colorAppointment.appointColor.appointtextcolor, value: colorAppointment.value, multiDiv: colorAppointment.multiDiv, orientation: this.model.orientation });
	                    $($(headerCell[resValue + groupIndex - 1]).find("div.e-appointwrapper")[cellIndex]).append(timeCellhtml);
	                    if (!ej.isNullOrUndefined(this.model.group) && this.model.group.resources.length > 1) {
	                        var appointColor = this._getResourceColor(record);
							var categoryClass= (appointColor.appointData == "")?"e-categorycolor":"";
	                        $($($(headerCell.find("td.e-resourceheadercells")).parent()[groupIndex - 1]).find("div.e-appointwrapper")[cellIndex]).append("<div class='e-categorybar "+categoryClass+"' id='categorybar_" + record[this.model.appointmentSettings["id"]] + "' style='position:absolute;height:" + (cellHeight - 3) + "px;background:" + appointColor.appointData + ";width:" + (appWidth + 1) + "px;left:" + leftPosition + "px;'></div>");
	                    }
	                }
	                else {
	                    if ($("#" + this._id + "_" + Globalize.format(new Date(record[this.model.appointmentSettings["startTime"]]), "MM_dd_yyyy") + "_" + (resValue + groupIndex - 1) + "_" + cellIndex).length == 0) {
	                        $($(headerCell[resValue + groupIndex - 1]).find("div.e-appointwrapper")[cellIndex]).append('<div id="' + this._id + "_" + Globalize.format(new Date(record[this.model.appointmentSettings["startTime"]]), "MM_dd_yyyy") + "_" + (resValue + groupIndex - 1) + "_" + cellIndex + '" class="e-icon e-appsoverflow"></div>');
	                        if (!ej.isNullOrUndefined(this.model.group) && this.model.group.resources.length > 1) {
	                            var appointColor = this._getResourceColor(record);
								var categoryClass= (appointColor.appointData == "")?"e-categorycolor":"";
	                            $($($(headerCell.find("td.e-resourceheadercells")).parent()[groupIndex - 1]).find("div.e-appointwrapper")[cellIndex]).append("<div class='e-categorybar "+categoryClass+"' id='categorybar_" + record[this.model.appointmentSettings["id"]] + "' style='position:absolute;height:" + (cellHeight - 3) + "px;background:" + appointColor.appointData + ";width:" + (appWidth + 1) + "px;left:" + leftPosition + "px;'></div>");
	                        }
	                        this.element.find("#" + this._id + "_" + Globalize.format(new Date(record[this.model.appointmentSettings["startTime"]]), "MM_dd_yyyy") + "_" + (resValue + groupIndex - 1) + "_" + cellIndex).css(this.model.enableRTL ? "right" : "left", (this.element.find(".e-workcells").width() + leftPosition - 25) + "px").css("top", topPosition + "px");
	                    }
	                }

	            }
	        }
	    },

	    _renderCategory: function (headerCell, groupIndex, record, cellHeight, minDate, maxDate, appointColor, timeScaleRowCount, day, startTime, endTime) {
	        var diffTime, diffDays, diffMinutes, cellIndex, appWidth, leftPosition;
	        if (record[this.model.appointmentSettings["allDay"]]) {
	            diffTime = new Date(Globalize.format(new Date(maxDate), this._pattern.d)) - new Date(Globalize.format(new Date(minDate), this._pattern.d)); // recordEnd.AddDays(1).Subtract(recordStart);
	            var diffDays = Math.round(diffTime / 86400000) + 1;
	            if (diffDays > this.dateRender.length) // if no of days excceeded the renderdates
	                diffDays = new Date(this.dateRender[this.dateRender.length - 1]).getDay() + 1 - new Date(minDate).getDay();
	            diffMinutes = (diffDays * 24 * 60); // minutes
	            cellIndex = ((this.model.endHour - this.model.startHour) * timeScaleRowCount) * day;
	            appWidth = ((this.element.find(".e-workcells").width() / (30 - 1.1)) * diffMinutes) + 3;
	            leftPosition = "0";
	        }
	        else if (new Date(Globalize.format(new Date(record[this.model.appointmentSettings["startTime"]]), this._pattern.d)) < new Date(Globalize.format(new Date(record[this.model.appointmentSettings["endTime"]]), this._pattern.d))) {
	            diffTime = new Date(Globalize.format(new Date(maxDate), this._pattern.d)) - new Date(Globalize.format(new Date(minDate), this._pattern.d));
	            var diffDays = Math.round(diffTime / 86400000) + 1;
	            diffMinutes = ((diffDays - 1) * 24 * 60); // minutes
	            cellIndex = (((this.model.endHour - this.model.startHour) * timeScaleRowCount) * day) + (startTime * timeScaleRowCount);
	            //  appWidth = Math.round((this.element.find(".e-workcells").width() / (30 - 1)) * diffMinutes) - (cellIndex * this.element.find(".e-workcells").width()) + "px";
	            appWidth = ((this.element.find(".e-workcells").width() / (30 - 1.1)) * diffMinutes) + (new Date(maxDate).getMinutes() * ((this.element.find(".e-workcells")[0].offsetWidth) * timeScaleRowCount) / 60) + ((new Date(maxDate).getHours() - this.model.startHour) * timeScaleRowCount);
	            if (diffDays > this.dateRender.length) // if no of days excceeded the renderdates
	            {
	                diffDays = new Date(this.dateRender[this.dateRender.length - 1]).getDay() + 1 - new Date(minDate).getDay();
	                diffMinutes = ((diffDays) * 24 * 60); // minutes
	                appWidth = ((this.element.find(".e-workcells").width() / (30 - 1.1)) * diffMinutes) - (cellIndex * 25) + 10;
	            }
	            leftPosition = (parseFloat((new Date(minDate).getMinutes())) * (this.element.find(".e-workcells")[0].offsetWidth) * timeScaleRowCount / 60);

	        }
	        else {
	            leftPosition = (parseFloat((new Date(minDate).getMinutes())) * (this.element.find(".e-workcells")[0].offsetWidth) * timeScaleRowCount / 60);
	            diffInMinutes = ((new Date(maxDate).getHours() * 60) + new Date(maxDate).getMinutes()) - ((new Date(minDate).getHours() * 60) + new Date(minDate).getMinutes());
	            appWidth = ((this.element.find(".e-workcells").width() / 30) * diffInMinutes) + ((new Date(maxDate).getHours() - new Date(minDate).getHours()) * timeScaleRowCount) - 2;
	            cellIndex = (((this.model.endHour - this.model.startHour) * timeScaleRowCount) * day) + (startTime * timeScaleRowCount);
	        }
	        if (!ej.isNullOrUndefined(this.model.group) && this.model.group.resources.length > 1)
	            $($($(headerCell.find("td.e-resourceheadercells")).parent()[groupIndex - 1]).find("div.e-appointwrapper")[cellIndex]).append("<div class='e-categorybar' style='position:absolute;height:" + (cellHeight - 3) + "px;background:" + appointColor.appointData + ";width:" + (appWidth + 1) + "px;left:" + leftPosition + "px;'></div>");

	    },

	    _getHorizontalOverlapCount: function (appointments, dateRender, day, record, resValue) {
	        var filterData = [];
	        for (var i = 0; i < appointments.length; i++) {
	            if (ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.resources) && !ej.isNullOrUndefined(this.model.group)) {
	                if ((Globalize.format(new Date(appointments[i][this.model.appointmentSettings["startTime"]]), this._pattern.d) <= Globalize.format(new Date(dateRender[day]), this._pattern.d)) &&
                    (Globalize.format(new Date(appointments[i][this.model.appointmentSettings["endTime"]]), this._pattern.d) >= Globalize.format(new Date(dateRender[day]), this._pattern.d)) &&
                    (((new Date(record[this.model.appointmentSettings["startTime"]]) < new Date(appointments[i][this.model.appointmentSettings["startTime"]]) && new Date(record[this.model.appointmentSettings["endTime"]]) >= new Date(appointments[i][this.model.appointmentSettings["startTime"]])) ||
                        (new Date(record[this.model.appointmentSettings["startTime"]]) < new Date(appointments[i][this.model.appointmentSettings["endTime"]]) && new Date(record[this.model.appointmentSettings["endTime"]]) > new Date(appointments[i][this.model.appointmentSettings["endTime"]])) ||
                        (new Date(record[this.model.appointmentSettings["startTime"]]) >= new Date(appointments[i][this.model.appointmentSettings["startTime"]]) && new Date(record[this.model.appointmentSettings["startTime"]]) < new Date(appointments[i][this.model.appointmentSettings["endTime"]])) ||
                        (new Date(record[this.model.appointmentSettings["endTime"]]) > new Date(appointments[i][this.model.appointmentSettings["startTime"]]) && new Date(record[this.model.appointmentSettings["endTime"]]) < new Date(appointments[i][this.model.appointmentSettings["endTime"]])))
                        && ((resValue != null) ? (resValue == appointments[i][this.model.resources[this.model.resources.length - 1]["field"]]) : resValue == null))) {
	                    filterData.push(appointments[i]);
	                }
	            }
	            else {
	                if ((Globalize.format(new Date(appointments[i][this.model.appointmentSettings["startTime"]]), this._pattern.d) <= Globalize.format(new Date(dateRender[day]), this._pattern.d)) &&
                    (Globalize.format(new Date(appointments[i][this.model.appointmentSettings["endTime"]]), this._pattern.d) >= Globalize.format(new Date(dateRender[day]), this._pattern.d)) &&
                    (((new Date(record[this.model.appointmentSettings["startTime"]]) < new Date(appointments[i][this.model.appointmentSettings["startTime"]]) && new Date(record[this.model.appointmentSettings["endTime"]]) >= new Date(appointments[i][this.model.appointmentSettings["startTime"]])) ||
                        (new Date(record[this.model.appointmentSettings["startTime"]]) < new Date(appointments[i][this.model.appointmentSettings["endTime"]]) && new Date(record[this.model.appointmentSettings["endTime"]]) > new Date(appointments[i][this.model.appointmentSettings["endTime"]])) ||
                        (new Date(record[this.model.appointmentSettings["startTime"]]) >= new Date(appointments[i][this.model.appointmentSettings["startTime"]]) && new Date(record[this.model.appointmentSettings["startTime"]]) < new Date(appointments[i][this.model.appointmentSettings["endTime"]])) ||
                        (new Date(record[this.model.appointmentSettings["endTime"]]) > new Date(appointments[i][this.model.appointmentSettings["startTime"]]) && new Date(record[this.model.appointmentSettings["endTime"]]) < new Date(appointments[i][this.model.appointmentSettings["endTime"]]))))) {
	                    filterData.push(appointments[i]);
	                }
	            }
	        }
	        return filterData;
	    },

	    _moveScroller: function () {
	        if (this.currentView() == "week" || this.currentView() == "workweek" || (this.currentView() === "customview" && this._renderDays <= 7)) {
	            if (this.element.find(".e-headercells").children().hasClass("e-activeview")) {
	                var currentDateIndex = $(this.element.find(".e-headercells").find(".e-activeview").parent()).index();
	                var cellOffsetLeft = this.element.find(".e-workcells")[currentDateIndex * 48].offsetLeft;
	                $(this.element.find(".e-horizontaltimecells").find("table tr")[2]).css("left", (-cellOffsetLeft) + "px");
	                $('div#' + this._id + "_scroller").ejScroller({ scrollLeft: cellOffsetLeft });
	            }
	        }
	    },


	    _renderHorizontalHeaderBar: function () {
	        var view = (this._isCustomView()) ? "month" : this.currentView(); var weekcols = Globalize.culture(this.model.locale);
	        var viewColCount = view == "day" ? 1 : view == "week" ? 7 : (this.currentView() === "customview" && this._renderDays <= 7) ? this._dateRender.length : 5;
	        
	        this.datesColumn = this._getHeaderAllDayCellsCount();
	        if (view === 'month' || (this._isCustomView())) {
	            this.datesColumn = [], this.monthDays = [], this.totdays = [];
	            for (var i = 0; i < this._dateRender.length; i++) {
	                if (this.currentView() === "month") {
	                    if (new Date(this.currentDate()).getMonth() === new Date(this._dateRender[i]).getMonth())
	                        this.totdays.push(new Date(this._dateRender[i]));
	                }
	                else
	                    this.totdays.push(new Date(this._dateRender[i]));
	            }
	            var date = this.totdays.length;
	            for (var i = 0; i < date; i++) {
	                curday = weekcols.calendar.days.names[new Date(this.totdays[i]).getDay()];
	                temp = { currentDate: Globalize.format(new Date(this.totdays[i]), "dd"), currentDateClass: "", currentDay: weekcols.calendar.days.names[new Date(this.totdays[i]).getDay()].toString().slice(0, 1), cellWidth: (!this.model.cellWidth && this.currentView() != "month" && !(this._isCustomView())) ? "30px" : this.model.cellWidth, cellHeight: this.model.cellHeight };
	                this.datesColumn.push(temp);
	                this.monthDays.push(new Date(this.totdays[i]));
	            }
	        }
	        var multiResources = (!ej.isNullOrUndefined(this.model.resources) && !ej.isNullOrUndefined(this.model.group)) ? true : false;
	        var html = this.horizontalHeader.render({ cols: this.datesColumn, multiRes: multiResources, view: view, timeTdCount: this._getStartEndTime(), colspan: view == "month" ? 1 : (this._getStartEndTime().length / viewColCount) * 2, height: view == 'month' ? 63 : 59, width: this.model.width, headercellWidth: view == "day" ? "100%" : "55px" });
	        this.aTR.append(html);
	    },

	    _renderHorizontalContent: function ($contentAreaDiv, $contentTable, $contentBody, $contentTR, $WorkCellTD, $scrollerbarDiv) {
	        var trCount, resHtml;
	        if (!ej.isNullOrUndefined(this.model.resources) && !ej.isNullOrUndefined(this.model.group)) {
	            resHtml = this._renderHorizontalResources();
	            trCount = this._horiResources;
	        }
	        else {
	            var tdWidth = this.currentView() == "month" || (this._isCustomView()) ? "24px" : "25px";
	            resHtml = "";
	            trCount = [{ classname: "e-childnode", tdWidth: tdWidth }];
	        }
	        //Work cells
	        var workCellhtml = this.cellTemplate.render({ cellrows: trCount, view: (this._isCustomView()) ? "month" : this.currentView(), cols: this.currentView() == 'month' || (this._isCustomView()) ? this.datesColumn : this._getStartEndTime() });
	        
	        this.wTR.append(ej.buildTag('td').append(resHtml)).append(ej.buildTag('td').append($contentAreaDiv.append($contentTable.append($contentBody.append($contentTR.append($WorkCellTD.append($scrollerbarDiv.append(this.$WorkCellDiv.append(workCellhtml)))))))));
	    },

	    _getResourceHeadTemplate: function (record) {
	        var userTemp = $.templates($(this.model.resourceHeaderTemplateId).html());
	        var userTempHtml = userTemp.render(record);
	        return userTempHtml;
	    },

	    _renderHorizontalResources: function(){
	        this._resCollect = []; this._horizontalResRender = []; this._horiResources = [];
	        this._renderMultipleResourceHeaderTemplate(null, null);
	        var view = this.currentView();
	        var viewColCount = view == "day" ? 1 : view == "week" || view == "month" || (this._isCustomView()) ? 7 : 5;
	        var tdWidth = this.currentView() == "month" || (this._isCustomView()) ? "24px" : "25px";
	        var userResTemplId = (this.model.resourceHeaderTemplateId) ? true : false;
	        var resTempHtml = "";
	        //     var resTempHtml = this._getResourceHeadTemplate(record);
	        if (!ej.isNullOrUndefined(this.model.group)) {
	            if (this.model.group.resources.length === 1) {
	                var index;
	                for (var i = 0; i < this.model.group.resources.length; i++) {
	                    index = this._findResourceIndex(this.model.resources, "name", this.model.group.resources[i]);
	                }
	                for (var i = 0; i < this._resourceInfo[index].dataSource.length; i++) {
	                    this._horiResources.push({ cellHeight: this.model.cellHeight, name: this._resourceInfo[index].dataSource[i][this._resourceInfo[index].text], idnum: this._resourceInfo[index].dataSource[i][this._resourceInfo[index].id], classname: "e-childnode", marginleft: "20px", width: "10px", backgroundcolor: "", border: "1px solid #bbbcbb", bordertop: "", tdWidth: tdWidth, userResHeader: this._getResourceHeadTemplate({ name: this._resourceInfo[index].dataSource[i][this._resourceInfo[index].text], classname: "e-childnode", id: this._resourceInfo[index].dataSource[i][this._resourceInfo[index].id], color: this._resourceInfo[index].dataSource[i][this._resourceInfo[index].color] }), userResTemplId: userResTemplId });
	                    this._resCollect.push(this._resourceInfo[index].dataSource[i]);
	                }
	                this._horizontalResRender.push(this._resCollect);
	            }
	            else {
	                var newResCollection = this._getResourceCollection();
	                var res = [], query, resApp, resourceHeaderHtml;

	                var d = 0;
	                var k = 0; var group = [];
	                
	                for (var j = 0; j < newResCollection[d].dataSource.length; j++) {
	                    this._horiResources.push({ cellHeight: this.model.cellHeight, name: newResCollection[d].dataSource[j].text, idnum: newResCollection[d].dataSource[j].id, classname: "e-parentnode", marginleft: "20px", width: "10px", backgroundcolor: "#bbbcbb", border: "1px solid #bbbcbb", bordertop: "1px solid #bbbcbb", tdWidth: tdWidth, userResHeader: this._getResourceHeadTemplate({ name: newResCollection[d].dataSource[j].text, classname: "e-parentnode", id: newResCollection[d].dataSource[j].id, color: newResCollection[d].dataSource[j].color }), userResTemplId: userResTemplId });
	                    this._resCollect.push(newResCollection[d].dataSource[j]);
	                    k++;

	                    for (i = 0; i < newResCollection[k].dataSource.length; i++) {
	                        p = k;
	                        if (newResCollection[k - 1].dataSource[j].id == newResCollection[k].dataSource[i].groupId) {
	                            group.push(newResCollection[k].dataSource[i]);
	                            this._horiResources.push({ cellHeight: this.model.cellHeight, name: newResCollection[k].dataSource[i].text, idnum: newResCollection[k].dataSource[i].id + "_" + newResCollection[k].dataSource[i].groupId, classname: "e-childnode", marginleft: "45px", width: "20px", backgroundcolor: "", border: "1px dotted #bbbcbb", bordertop: "", tdWidth: tdWidth, userResHeader: this._getResourceHeadTemplate({ name: newResCollection[k].dataSource[i].text, classname: "e-childnode", id: newResCollection[k].dataSource[i].id, color: newResCollection[k].dataSource[i].color }), userResTemplId: userResTemplId });
	                            this._resCollect.push(newResCollection[k].dataSource[i]);
	                            while (k < newResCollection.length - 1) {
	                                for (var m = 0; m < newResCollection[k + 1].dataSource.length; m++) {
	                                    if (newResCollection[k].dataSource[i].id == newResCollection[k + 1].dataSource[m].groupId) {
	                                        group.push(newResCollection[k + 1].dataSource[m]);
	                                        this._horiResources.push({ cellHeight: this.model.cellHeight, name: newResCollection[k + 1].dataSource[m].text, classname: "e-childnode", marginleft: "55px", width: "20px", backgroundcolor: "", border: "1px dotted #bbbcbb", bordertop: "", tdWidth: tdWidth, userResHeader: this._getResourceHeadTemplate({ name: newResCollection[k + 1].dataSource[m].text, classname: "e-childnode", id: newResCollection[k + 1].dataSource[m].id, color: newResCollection[k + 1].dataSource[m].color }), userResTemplId: userResTemplId });
	                                        this._resCollect.push(newResCollection[k + 1].dataSource[m]);
	                                    }
	                                }
	                                k++;
	                            }

	                        }
	                        k = p;
	                    }
	                    k = 0;
	                }

	                //           debugger;

	                // for (var resCollect = 0; resCollect < newResCollection.length - 1; resCollect++) {
	                //     for (var i = 0; i < newResCollection[resCollect].dataSource.length; i++) {
	                //         var j = i + 1;
	                //         this._horiResources.push({ name: newResCollection[j - 1].dataSource[i].text, classname: "e-parentnode", marginleft: "50px", width: "10px", backgroundcolor: "#bbbcbb", border: "1px solid #bbbcbb", bordertop: "1px solid #bbbcbb" });
	                //         this._resCollect.push(newResCollection[j - 1].dataSource[i]);

	                //    //     while (j <= newResCollection.length - 1) {
	                //             //    query = new ej.Query().where("groupId", ej.FilterOperators.equal, newResCollection[j-1].dataSource[i][newResCollection[j-1].id]);
	                //             //    resApp = new ej.DataManager(newResCollection[j].dataSource).executeLocal(query); //this._resourceManager1.executeLocal(query);
	                //             //    if (resApp.length > 0) {
	                //             //        for (var a = 0; a < resApp.length; a++) {
	                //             //            if (newResCollection[j - 1].dataSource[i].id == resApp[a].groupId) {
	                //             //                this._horiResources.push({ name: resApp[a].text, classname: "e-childnode", marginleft: "80px", width: "20px", backgroundcolor: "", border: "1px dotted #bbbcbb", bordertop: "" });
	                //             //                this._resCollect.push(resApp[a]);
	                //             //            }
	                //             //        }
	                //             //    }
	                //             //j++;
	                //   //      }
	                //     }
	                //}
	                this._horizontalResRender.push(this._resCollect);
	            }
	        }
	        else {
	            for (var k = 0; k < this.model.resources.length; k++) {
	                this._horizontalResRender.push(this.model.resources[k].resourceSettings.dataSource);
	                this._resCollect.push(this.model.resources[k].resourceSettings.dataSource);
	            }
	        }
	        var html = this.horizontalResHeader.render({ trs: this._horiResources });
	        return html;
	    },

	    _renderHorizontalCurrentTime: function () {
	        if (this.currentView() !== "month" && !(this._isCustomView())) {
	            if (this.element.find("td.e-headerToday").length > 0) {
	                this.element.find('.e-horizontaltabletimecell').append('<div id="' + this._id + '_HighlightCurrentTimeline" class="e-highlightcurrenttimeline" style="height: 92%; width: 2px; position: absolute; background-color: red; "></div>')
	                $('#' + this._id + '_HighlightCurrentTimeline').css("top", this.element.find('.e-headerdays tr')[1].offsetTop);
	            }
	        }
	        else {
	            var monthDays = [];
	            for (var k = 0; k < this._dateRender.length; k++) {
	                if (new Date(this.currentDate()).getMonth() === new Date(this._dateRender[k]).getMonth())
	                    monthDays.push(new Date(this._dateRender[k]));
	            }
	            var target = this.element.find(".e-workcells");
	            for (var i = 0; i < monthDays.length; i++) {
	                if (Globalize.format(new Date(monthDays[i]), this._pattern.d) === Globalize.format(new Date(), this._pattern.d))
	                    $(target[i]).addClass("e-monthcurrenttime");
	            }
	        }
	    },

	    _horizontalTimePosition: function (temp, now) {
	        if (temp.element.find("td.e-headerToday").length > 0) {
	            var headertodaypos = temp.element.find("td.e-headerToday")[0].cellIndex;
	            var startTime = (now.getHours() - temp.model.startHour);
	            var cellIndex = (((temp.model.endHour - temp.model.startHour) * 2) * headertodaypos) + (startTime * 2);
	            var leftPosition = (parseFloat((now.getMinutes())) * (temp.element.find(".e-workcells")[0].offsetWidth) * 2 / 60);
	            $('#' + temp._id + '_HighlightCurrentTimeline').css("left", (cellIndex * temp.element.find(".e-workcells")[0].offsetWidth) + leftPosition);
	        }
	    },

	    _horizontalBusinessHighlight: function (renderDates, b_startHour, b_endHour, timeRowsCount, target) {
	        var tdLength = (ej.scheduleFeatures.resources && !ej.isNullOrUndefined(this.model.group)) ? this._horiResources.length : 1;
	        if (this.currentView() !== "month" && !(this._isCustomView())) {
	            for (var res = 0; res < tdLength; res++) {
	                for (var k = 0; k < renderDates.length; k++) {
	                    for (var i = (b_startHour * timeRowsCount) ; i < (b_endHour * timeRowsCount) ; i++) {
	                        if (new Date(renderDates[k]).getDay() !== 0 && new Date(renderDates[k]).getDay() !== 6)
	                            $($(this.element.find(".e-workcellstab tr")[res]).find(".e-workcells")[i + (((this.model.endHour - this.model.startHour) * timeRowsCount) * k)]).addClass("e-businesshighlightworkcells");
	                    }
	                }
	            }
	            this._businessHourScroller();
	        }
	        else {
	            var monthDays = this.monthDays;
	            var target = this.element.find(".e-workcells");target.removeClass("e-monthcellhighlight");
	            for (var res = 0; res < tdLength; res++) {
	                for (var i = 0; i < monthDays.length; i++) {
	                    if (new Date(monthDays[i]).getDay() !== 0 && new Date(monthDays[i]).getDay() !== 6)
	                        $($(this.element.find(".e-workcellstab tr")[res]).find(".e-workcells")[i]).addClass("e-monthcellhighlight");
	                }
	            }
	        }
	    },

	    _onResourceClick: function (e) {
	        var target = $(e.currentTarget);
	        if (target.hasClass("e-resourceicon e-resourcecollapse")) {
	            target.removeClass("e-resourceicon e-resourcecollapse");
	            target.addClass("e-resourceicon e-resourceexpand");
	        }
	        else {
	            target.removeClass("e-resourceicon e-resourceexpand");
	            target.addClass("e-resourceicon e-resourcecollapse");
	        }
	        var index = $(e.currentTarget).parent().index(); var newResCollection = this._getResourceCollection();
	        var query = new ej.Query().where("groupId", ej.FilterOperators.equal, parseInt(e.currentTarget.id));
	        var resApp = new ej.DataManager(newResCollection[newResCollection.length - 1].dataSource).executeLocal(query);
	        for (var i = index + 1; i <= (resApp.length + index) ; i++) {
	            $(this.element.find(".e-resourceheadertable").find("tr")[i]).toggle();
	            $(this.element.find(".e-workcellstab").find("tr")[i]).toggle();
	        }
	        this._renderScroller();
	        this.element.find("div.e-prev").remove();
	        this.element.find("div.e-next").remove();
	        this.element.find(".e-horires").css("top", "0px");
	        this._businessHourScroller();
	    },

	};

})(jQuery, Syncfusion);