﻿(function ($, ej, undefined) {
	ej.scheduleFeatures = ej.scheduleFeatures || {};

	var resourceHeadTemplate = function () {
	    this._resHeadTemplate = (
        "{{for resourceName}}{{for ~cols=colspan}}<td class='e-resourcecells 'style='height:27px;' colspan='{{:~cols}}'> {{for ~resource=resourceNam}}<div align='center'>{{if userResTemplId == true}}{{:userResHeader}}{{else}}{{:~resource}}{{/if}}</div>{{/for}}  </td>{{/for}}{{/for}}");
	    return this._resHeadTemplate;
	};

	ej.scheduleFeatures.resources = {

	    __getMultipleResourceCellsCount: function (count) {
	        if (this.model.group.resources.length === 1) {
	            var index;
	            for (var i = 0; i < this.model.group.resources.length; i++) {
	                index = this._findResourceIndex(this.model.resources, "name", this.model.group.resources[i]);
	            }
	            resCount = this._resourceInfo[index].dataSource.length; // this.model.resources[index].dataSource.length;
	        }
	        else {
	            var newResCollection = this._getResourceCollection(), resources = [];
	            var groupData, prevGroupDataId, query, resApp;
	            for (var j = 0; j < newResCollection.length; j++) {
	                resources = [];
	                if (j == 0) {
	                    for (var i = 0; i < newResCollection[j].dataSource.length; i++) {
	                        resources.push({ resourceNam: newResCollection[j].dataSource[i][newResCollection[j].text] });
	                    }
	                }
	                else {
	                    if (j > 1) {
	                        newResCollection[j - 1].dataSource = [];
	                        newResCollection[j - 1].dataSource = this.res;
	                    }
	                    this.res = [];
	                    groupData = ej.group(newResCollection[j].dataSource, newResCollection[j].groupId);
	                    prevGroupDataId = ej.group(newResCollection[j - 1].dataSource, newResCollection[j - 1].id);
	                    this._resourceManager1 = groupData instanceof ej.DataManager ? groupData : ej.DataManager(groupData);
	                    for (var l = 0; l < prevGroupDataId.length; l++) {
	                        for (var k = 0; k < prevGroupDataId[l].items.length; k++) {
	                            query = new ej.Query().where("key", ej.FilterOperators.equal, prevGroupDataId[l].items[k][newResCollection[j].id]);
	                            resApp = this._resourceManager1.executeLocal(query);
	                            if (resApp.length > 0) {
	                                for (var a = 0; a < resApp[0].items.length; a++) {
	                                    resources.push({ resourceNam: resApp[0].items[a][newResCollection[j].text] });
	                                    this.res.push(resApp[0].items[a]);
	                                }
	                            }
	                        }
	                    }
	                }
	            }
	            resCount = resources.length;
	        }
	        count = count * resCount; // this.res1.length;
	        return { resCount: resCount, count: count };
	    },
	    /**
                * To configure the dataSource values to the resource fields.
                * @private
                */
	    _initResourceData: function (fields, i) {
	        var query = this._columnToSelect(fields);
	        var proxy = this;
	        var queryPromise = fields.dataSource.executeQuery(query);
	        queryPromise.done(function (e) {
	            fields.dataSource = e.result;
	            proxy._resourceInfo.push(fields);
	            if (i == proxy.model.resources.length - 1)
	                proxy._renderInitSchedule();
	        });
	    },

	    _showMultipleResourceDetails: function (temp) {
	        var prevdata, query, resApp1, fieldCollection = [];
	        if (this.model.resources.length > 0) {
	            var newResCollection = this._getResourceCollection();
	            for (var i = 0; i < newResCollection.length; i++) {
	                this._appointmentAddWindow.find('.owner_' + i).ejAutocomplete("clearText");
	            }
	            for (var j = 0; j < this.render_Resources.length - 1; j++) {
	                prevdata = this.render_Resources[j + 1] instanceof ej.DataManager ? this.render_Resources[j + 1] : ej.DataManager(this.render_Resources[j + 1]);
	                query = new ej.Query().where(newResCollection[j + 1].groupId, ej.FilterOperators.equal, temp[this.model.appointmentSettings.resourceFields.toString().split(',')[j]]);
	                resApp1 = prevdata.executeLocal(query);
	                fieldCollection = [];
	                for (var k = 0; k < resApp1.length; k++) {

	                    fieldCollection.push({ text: resApp1[k][newResCollection[j + 1].text], value: resApp1[k][newResCollection[j + 1].id], color: resApp1[k][newResCollection[j + 1].color] });
	                }
	                this._appointmentAddWindow.find('.owner_' + (j + 1)).ejAutocomplete("clearText");
	                this._appointmentAddWindow.find('.owner_' + (j + 1)).ejAutocomplete("option", "dataSource", fieldCollection);

	            }
	            for (var i = 0; i < newResCollection.length; i++) {
	                this._appointmentAddWindow.find('.owner_' + i).data("ejAutocomplete").selectValueByKey(temp[this.model.appointmentSettings.resourceFields.toString().split(',')[i]]);
	            }
	        }
	    },

	    _renderAppWindowResources: function (control) {
	        var newResCollection = this._getResourceCollection(), fieldCollection = [];
	        for (var i = 0; i < newResCollection.length; i++) {
	            fieldCollection = [];
	            for (var j = 0; j < this.render_Resources[i].length; j++) {
	                fieldCollection.push({ text: this.render_Resources[i][j][newResCollection[i].text], value: this.render_Resources[i][j][newResCollection[i].id], color: this.render_Resources[i][j][newResCollection[i].color] });
	            }
	            if (!this.model.resources[i].allowMultiple)
	                control.find('.owner_' + i).ejAutocomplete({
	                    enableRTL: this.model.enableRTL,
	                    showPopupButton: true,
	                    width: "100%", cssClass: this.model.cssClass,
	                    multiSelectMode: "none",
	                    dataSource: fieldCollection, fields: { text: "text", key: "value" }, change: this._onResourceChange,
	                    template: this.resourceTemplate
	                });
	            else
	                control.find('.owner_' + i).ejAutocomplete({
	                    enableRTL: this.model.enableRTL,
	                    showPopupButton: true,
	                    width: "100%", cssClass: this.model.cssClass,
	                    multiSelectMode: "visualmode",
	                    dataSource: fieldCollection, fields: { text: "text", key: "value" }, change: this._onResourceChange,
	                    template: this.resourceTemplate
	                });
	        }
	    },

	    _onResourceChange: function (e) {
	        var scheduleDiv = $("#" + this._id.toString().split("_")[0]), proxy = scheduleDiv.ejSchedule("instance");
	        var controlId = parseInt(this._id.toString().split("_")[2]);
	        var controlMode = proxy._appointmentAddWindow.find('.owner_' + controlId).ejAutocomplete("option", "multiSelectMode")
	        var selectedItems = this.getSelectedItems();
	        var resourceCollection = proxy._getResourceCollection();
	        if (controlId < proxy.render_Resources.length - 1 && selectedItems.length > 0) {
	            var j = controlId + 1;
	            var data = proxy.render_Resources[j - 1] instanceof ej.DataManager ? proxy.render_Resources[j - 1] : ej.DataManager(proxy.render_Resources[j - 1]);
	            var prevdata = proxy.render_Resources[j] instanceof ej.DataManager ? proxy.render_Resources[j] : ej.DataManager(proxy.render_Resources[j]);
	            if (controlMode == "none") {
	                if (!ej.isNullOrUndefined(e.value)) {
	                    var textCheck = new ej.Query().where(resourceCollection[j - 1].text, ej.FilterOperators.equal, e.value);
	                    var result = data.executeLocal(textCheck);
	                }
	                var currentVal = ((!e.value) || ej.isNullOrUndefined(e.value) || result.length <= 0) ? selectedItems[0].value : selectedItems[1].value;
	                if (!ej.isNullOrUndefined(currentVal)) {
	                    var query = new ej.Query().where(resourceCollection[j - 1].id, ej.FilterOperators.equal, currentVal);
	                    var resApp = data.executeLocal(query);

	                    var query = new ej.Query().where(resourceCollection[j].groupId, ej.FilterOperators.equal, resApp[0][resourceCollection[j - 1].id]);
	                    var resApp1 = prevdata.executeLocal(query);
	                    var fieldCollection = [];
	                    for (var k = 0; k < resApp1.length; k++) {
	                        fieldCollection.push({ text: resApp1[k][resourceCollection[j].text], value: resApp1[k][resourceCollection[j].id], color: resApp1[k][resourceCollection[j].color] });
	                    }
	                    proxy._appointmentAddWindow.find('.owner_' + j).ejAutocomplete("clearText");
	                    proxy._appointmentAddWindow.find('.owner_' + j).ejAutocomplete("option", "dataSource", fieldCollection); //.data("ejAutocomplete").selectValueByKey(resApp1[0].id);
	                    proxy._appointmentAddWindow.find('.owner_' + j).data("ejAutocomplete").selectValueByKey(resApp1[0][resourceCollection[j].id]);
	                    selectedItems = resApp1[0][resourceCollection[j].id];
	                }
	            }
	            else {
	                var predicate;
	                predicate = ej.Predicate(resourceCollection[j - 1].id, ej.FilterOperators.equal, selectedItems[0].value);
	                for (var i = 1; i < selectedItems.length; i++) {
	                    predicate = predicate["or"](resourceCollection[j - 1].id, ej.FilterOperators.equal, selectedItems[i].value);
	                }
	                var query = new ej.Query().where(predicate);
	                var resApp = data.executeLocal(query);

	                if (resApp.length > 0) {
	                    var prev_predicate;
	                    prev_predicate = ej.Predicate(resourceCollection[j].groupId, ej.FilterOperators.equal, resApp[0][resourceCollection[j - 1].id]);
	                    for (var i = 1; i < resApp.length; i++) {
	                        prev_predicate = prev_predicate["or"](resourceCollection[j].groupId, ej.FilterOperators.equal, resApp[i][resourceCollection[j - 1].id]);
	                    }
	                    var query = new ej.Query().where(prev_predicate);
	                    var resApp1 = prevdata.executeLocal(query);

	                    var fieldCollection = [];
	                    for (var k = 0; k < resApp1.length; k++) {
	                        fieldCollection.push({ text: resApp1[k][resourceCollection[j].text], value: resApp1[k][resourceCollection[j].id], color: resApp1[k][resourceCollection[j].color] });
	                    }
	                    proxy._appointmentAddWindow.find('.owner_' + j).ejAutocomplete("clearText");
	                    proxy._appointmentAddWindow.find('.owner_' + j).ejAutocomplete("option", "dataSource", fieldCollection); //.data("ejAutocomplete").selectValueByKey(resApp1[0].id);
	                    proxy._appointmentAddWindow.find('.owner_' + j).data("ejAutocomplete").selectValueByKey(resApp1[0][resourceCollection[j].id]);
	                    selectedItems.push(resApp1[0][resourceCollection[j].id]);
	                }


	            }
	        }
	    },

	    _getResourceCollection: function () {
	        var resIndexCollection = [], index;
	        if (!ej.isNullOrUndefined(this.model.resources)) {
	            if (!ej.isNullOrUndefined(this.model.group)) {
	                for (var i = 0; i < this.model.group.resources.length; i++) {
	                    index = this._findResourceIndex(this.model.resources, "name", this.model.group.resources[i]);
	                    resIndexCollection.push({ index: index, name: this.model.resources[i].name });
	                }
	                resIndexCollection = resIndexCollection.sort(function (a, b) {
	                    var x = a.index; var y = b.index;
	                    return ((x < y) ? -1 : ((x > y) ? 1 : 0));
	                });
	            }
	            else {
	                for (var i = 0; i < this.model.resources.length; i++) {
	                    resIndexCollection.push({ index: i });
	                }
	            }
	            var newResCollection = [];
	            for (var k = 0; k < resIndexCollection.length; k++) {
	                newResCollection.push(this._resourceInfo[resIndexCollection[k].index]);
	            }
	            return newResCollection;
	        }

	    },

	    _renderMultipleResourceHeaderTemplate: function (tbody, cols) {
	        this.res1 = []; this.render_Resources = []; this.level_Resources = [];
	        var view = this.currentView();
	        var viewColCount = view == "day" ? 1 : view == "week" || view == "month" ? 7 : 5;
	        if (!ej.isNullOrUndefined(this.model.group)) {
	            var userResTemplId = (this.model.resourceHeaderTemplateId) ? true : false;
	            if (this.model.group.resources.length === 1) {
	                var index;
	                for (var i = 0; i < this.model.group.resources.length; i++) {
	                    index = this._findResourceIndex(this.model.resources, "name", this.model.group.resources[i]);
	                }
	                var resources = [];
	                for (var i = 0; i < this._resourceInfo[index].dataSource.length; i++) {
	                    resources.push({ resourceNam: this._resourceInfo[index].dataSource[i][this._resourceInfo[index].text].toUpperCase(), colspan: viewColCount, userResHeader: this._getResourceHeadTemplate({ name: this._resourceInfo[index].dataSource[i][this._resourceInfo[index].text], classname: "e-childnode", id: this._resourceInfo[index].dataSource[i][this._resourceInfo[index].id], color: this._resourceInfo[index].dataSource[i][this._resourceInfo[index].color] }), userResTemplId: userResTemplId });
	                    this.res1.push(this._resourceInfo[index].dataSource[i]);
	                    this.level_Resources.push(this.res1[i]);
	                }
	                this.render_Resources.push(this.res1);
	                if (this.model.orientation == "vertical" && tbody !== null && cols != null) {
	                    leftCellwidth = view == "month" ? 50 : 56;
	                    var resourceHeaderHtml = this.resourceHeadTemplate.render({ cols: cols, resourceName: resources, leftWidth: leftCellwidth });
	                    tbody.append(ej.buildTag('tr.e-headerbar').append(resourceHeaderHtml));
	                }
	            }
	            else {
	                var newResCollection = this._getResourceCollection();
	                var res = [], resources = [], prevGroupDataId, query, resApp, tres = [], group, leftCellwidth, resourceHeaderHtml;
	                for (var j = 0; j < newResCollection.length; j++) {
	                    resources = []; this.level_Resources = [];
	                    if (j >= 0 && j < newResCollection.length - 1) {
	                        prevGroupDataId = ej.group(newResCollection[j + 1].dataSource, newResCollection[j + 1].groupId);
	                        this._resourceManager1 = prevGroupDataId instanceof ej.DataManager ? prevGroupDataId : ej.DataManager(prevGroupDataId);

	                        for (var i = 0; i < newResCollection[j].dataSource.length; i++) {
	                            query = new ej.Query().where("key", ej.FilterOperators.equal, newResCollection[j].dataSource[i][newResCollection[j].id]);
	                            resApp = this._resourceManager1.executeLocal(query);
	                            if (resApp.length > 0) {
	                                for (var a = 0; a < resApp[0].items.length; a++) {
	                                    if (newResCollection[j].dataSource[i].id == resApp[0].items[a].groupId) {
	                                        res.push(resApp[0].items[a]);
	                                        (j == newResCollection.length - 2) ? this.res1.push(resApp[0].items[a]) : this.res1 = [];
	                                    }
	                                }
	                            }
	                            tres = [];
	                            for (m = j + 1; m < newResCollection.length; m++) {
	                                group = ej.group(newResCollection[m].dataSource, newResCollection[m].groupId);
	                                this._resourceData = group instanceof ej.DataManager ? group : ej.DataManager(group);
	                                if (m > j + 1) {
	                                    this.tres = [];
	                                    for (var l = 0; l < tres.length; l++) {
	                                        query = new ej.Query().where("key", ej.FilterOperators.equal, tres[l].id);
	                                        resApp = this._resourceData.executeLocal(query);
	                                        if (resApp.length > 0) {
	                                            for (var a = 0; a < resApp[0].items.length; a++) {
	                                                this.tres.push(resApp[0].items[a]);
	                                            }
	                                        }
	                                    }
	                                } else {
	                                    query = new ej.Query().where("key", ej.FilterOperators.equal, newResCollection[m - 1].dataSource[i].id);
	                                    resApp = this._resourceData.executeLocal(query);
	                                    if (resApp.length > 0) {
	                                        for (var a = 0; a < resApp[0].items.length; a++) {
	                                            tres.push(resApp[0].items[a]);
	                                        }
	                                    }
	                                }

	                            }

	                            if (tres.length > 0) {
	                                if (j == 0 && !ej.isNullOrUndefined(this.tres))
	                                    resources.push({ resourceNam: newResCollection[j].dataSource[i][newResCollection[j].text], colspan: this.tres.length * viewColCount, userResHeader: this._getResourceHeadTemplate({ name: newResCollection[j].dataSource[i][newResCollection[j].text], classname: "e-childnode", id: newResCollection[j].dataSource[i][newResCollection[j].id], color: newResCollection[j].dataSource[i][newResCollection[j].color] }), userResTemplId: userResTemplId });
	                                else
	                                    resources.push({ resourceNam: newResCollection[j].dataSource[i][newResCollection[j].text], colspan: tres.length * viewColCount, userResHeader: this._getResourceHeadTemplate({ name: newResCollection[j].dataSource[i][newResCollection[j].text], classname: "e-parentnode", id: newResCollection[j].dataSource[i][newResCollection[j].id], color: newResCollection[j].dataSource[i][newResCollection[j].color] }), userResTemplId: userResTemplId });
	                                this.level_Resources.push(newResCollection[j].dataSource[i]);
	                            }
	                            res = [];
	                        }
	                    }
	                    else {
	                        for (var i = 0; i < this.res1.length; i++) {
	                            resources.push({ resourceNam: this.res1[i][newResCollection[j].text].toUpperCase(), colspan: viewColCount, userResHeader: this._getResourceHeadTemplate({ name: this.res1[i][newResCollection[j].text], classname: "e-childnode", id: this.res1[i][newResCollection[j].id], color: this.res1[i][newResCollection[j].color] }), userResTemplId: userResTemplId });
	                            this.level_Resources.push(this.res1[i]);
	                        }
	                    }
	                    this.render_Resources.push(this.level_Resources);
	                    if (this.model.orientation == "vertical" && tbody !== null && cols != null) {
	                        leftCellwidth = view == "month" ? 50 : 56;
	                        resourceHeaderHtml = this.resourceHeadTemplate.render({ cols: cols, resourceName: resources, leftWidth: leftCellwidth });
	                        tbody.append(ej.buildTag('tr.e-headerbar').append(resourceHeaderHtml));
	                    }
	                }
	            }

	        }
	        else {
	            for (var k = 0; k < this.model.resources.length; k++) {
	                this.render_Resources.push(this.model.resources[k].resourceSettings.dataSource);
	            }
	        }
	        return tbody;
	    },

	    _getMultipleResourceColsCount: function (cols) {
	        if (this.model.group.resources.length === 1) {
	            for (var i = 0; i < this.model.group.resources.length; i++) {
	                index = this._findResourceIndex(this.model.resources, "name", this.model.group.resources[i]);
	            }
	            if (this._resourceInfo[index].dataSource.length > 0) {
	                cols = cols * this._resourceInfo[index].dataSource.length;
	            }
	        }
	        else {
	            var newResCollection = this._getResourceCollection();
	            if (newResCollection[newResCollection.length - 1].dataSource.length > 0) {
	                cols = cols * this.res1.length;
	            }
	        }
	        return cols;
	    },

	    _getMultipleResourceAppList: function (app, dateCount, appointmentsList, res, day) {
	        if ((Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["startTime"]]), this._pattern.d) <= Globalize.format(new Date(dateCount[day]), this._pattern.d)) && (appointmentsList[app][this.model.appointmentSettings.resourceFields.toString().split(',')[this.model.resources.length - 1]] == this.res1[res][this.model.resources[this.model.resources.length - 1].resourceSettings.id]) && (Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["endTime"]]), this._pattern.d) >= Globalize.format(new Date(dateCount[day]), this._pattern.d)) && (Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["startTime"]]), this._pattern.d) == Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["endTime"]]), this._pattern.d)) && (appointmentsList[app][this.model.appointmentSettings["allDay"]] === false) && (Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["startTime"]]), this._pattern.d) <= Globalize.format(new Date(appointmentsList[app][this.model.appointmentSettings["endTime"]]), this._pattern.d))) {
	            var id = this._processed[app].ParentId;
	            var query = new ej.Query().where(this.model.appointmentSettings["id"], ej.FilterOperators.equal, parseInt(id));
	            var list = this._currentAppointmentData;
	            var templist = new ej.DataManager(list).executeLocal(query);
	            if (this.currentView() == "day") {
	                (((new Date(templist[0][this.model.appointmentSettings["endTime"]]) - new Date(templist[0][this.model.appointmentSettings["startTime"]])) / 3600000) > 24) ? this._setAllDayPos(appointmentsList[app], day, res) : this._appList.push(appointmentsList[app]);
	            }
	            else { this._appList.push(appointmentsList[app]); }
	        }
	    },

	    _getMultipleResourceAlldayApp: function (renderDate, day, res, i) {
	        if ((Globalize.format(new Date(renderDate[day]), this._pattern.d) == Globalize.format(new Date(this._processed[i][this.model.appointmentSettings["startTime"]]), this._pattern.d)) && (this._processed[i][this.model.appointmentSettings.resourceFields.toString().split(',')[this.model.resources.length - 1]] == this.res1[res][this.model.resources[this.model.resources.length - 1].resourceSettings.id]) &&
				(this._processed[i][this.model.appointmentSettings["allDay"]] === true || (((new Date(this._processed[i][this.model.appointmentSettings["endTime"]]) - new Date(this._processed[i][this.model.appointmentSettings["startTime"]])) / 3600000) > 24))) {
	            //level = this._getOverlapCount(this._processed[i], day, renderDate);
	            this._setAllDayPos(this._processed[i], day, res);
				this._filtered.push(this._processed[i]);
	        }
	    },

	    _getMonthAppList: function (renderDate, day, appointments, app, res) {
	        if ((appointments[app][this.model.appointmentSettings["allDay"]] == true) || (((new Date(appointments[app][this.model.appointmentSettings["endTime"]]) - new Date(appointments[app][this.model.appointmentSettings["startTime"]])) / 3600000) > 24)) {
	            if ((Globalize.format(new Date(renderDate[day]), this._pattern.d) == Globalize.format(new Date(appointments[app][this.model.appointmentSettings["startTime"]]), this._pattern.d)) &&
                (Globalize.format(new Date(renderDate[day]), this._pattern.S) <= Globalize.format(new Date(appointments[app][this.model.appointmentSettings["endTime"]]), this._pattern.S)) &&
                (appointments[app][this.model.appointmentSettings.resourceFields.toString().split(',')[this.model.resources.length - 1]] == this.res1[res][this.model.resources[this.model.resources.length - 1].resourceSettings.id]) &&
                (Globalize.format(new Date(appointments[app][this.model.appointmentSettings["startTime"]]), this._pattern.S) <= Globalize.format(new Date(appointments[app][this.model.appointmentSettings["endTime"]]), this._pattern.S))) {
	                this.filterData.push(appointments[app]);
	            }
	        } else {
	            if ((Globalize.format(new Date(renderDate[day]), this._pattern.d) == Globalize.format(new Date(appointments[app][this.model.appointmentSettings["startTime"]]), this._pattern.d)) &&
                (Globalize.format(new Date(renderDate[day]), this._pattern.d) <= Globalize.format(new Date(appointments[app][this.model.appointmentSettings["endTime"]]), this._pattern.d)) &&
                (appointments[app][this.model.appointmentSettings.resourceFields.toString().split(',')[this.model.resources.length - 1]] == this.res1[res][this.model.resources[this.model.resources.length - 1].resourceSettings.id]) &&
                (Globalize.format(new Date(appointments[app][this.model.appointmentSettings["startTime"]]), this._pattern.d) <= Globalize.format(new Date(appointments[app][this.model.appointmentSettings["endTime"]]), this._pattern.d))) {
	                this.filterData.push(appointments[app]);
	            }
	        }
	        return this.filterData;
	    },

	    _getResourceColor: function (record) {
	        var newResCollection = this._getResourceCollection();
	        var resourceDataIndex, appointData = "", appointCustomcss = "";
	        if (!ej.isNullOrUndefined(this.model.group)) {
	            resourceDataIndex = this._findResourceIndex(this.render_Resources[0], newResCollection[0].id, record[this.model.appointmentSettings.resourceFields.split(',')[0]]);
	            if (!ej.isNullOrUndefined(resourceDataIndex)) {
	                appointData = !ej.isNullOrUndefined(this.render_Resources[0][resourceDataIndex][newResCollection[0].color]) ? this.render_Resources[0][resourceDataIndex][newResCollection[0].color] : appointData;
	                appointCustomcss = !ej.isNullOrUndefined(this.render_Resources[0][resourceDataIndex][newResCollection[0].appointmentClass]) ? this.render_Resources[0][resourceDataIndex][newResCollection[0].appointmentClass] : appointCustomcss;
	            }
	        }
	        else {
	            resourceDataIndex = this._findResourceIndex(this.render_Resources[this.render_Resources.length - 1], newResCollection[newResCollection.length - 1].id, record[this.model.appointmentSettings.resourceFields.split(',')[this.model.appointmentSettings.resourceFields.split(',').length - 1]]);
	            if (!ej.isNullOrUndefined(resourceDataIndex)) {
	                appointData = !ej.isNullOrUndefined(this.render_Resources[this.render_Resources.length - 1][resourceDataIndex][newResCollection[newResCollection.length - 1].color]) ? this.render_Resources[this.render_Resources.length - 1][resourceDataIndex][newResCollection[newResCollection.length - 1].color] : appointData;
	                appointCustomcss = !ej.isNullOrUndefined(this.render_Resources[this.render_Resources.length - 1][resourceDataIndex][newResCollection[newResCollection.length - 1].appointmentClass]) ? this.render_Resources[this.render_Resources.length - 1][resourceDataIndex][newResCollection[newResCollection.length - 1].appointmentClass] : appointCustomcss;
	            }
	        }
	        return { appointData: appointData, appointCustomcss: appointCustomcss };
	    },

	    _getResourceDetails: function (_target) {
	        if (!ej.isNullOrUndefined(this.model.resources)) {
	            if (this.model.resources.length > 0) {
	                var noOfDays = this.model.currentView === "week" || this.model.currentView === "month" ? 7 : this.model.currentView === "workweek" ? 5 : 1;
	                var index = this.model.currentView === "month" ? _target.index() : this._cellIndex;

	                index = this.model.orientation == "vertical" ? parseInt(index / noOfDays) : this._workCellIndex;
	                var res1 = this.model.orientation == "vertical" ? this.res1 : this._resCollect;

	                var group, resourceData, query, result; this._resourceCollection = [];
	                var newResCollection = this._getResourceCollection();

	                for (var i = newResCollection.length - 1; i >= 0; i--) {
	                    if (i == newResCollection.length - 1) {

	                        if (!ej.isNullOrUndefined(this.model.group)) {
	                            this._resourceCollection.push({ id: res1[index][newResCollection[i].id] });
	                            group = res1[index][newResCollection[i].groupId];
	                        }
	                        else {
	                            this._resourceCollection.push({ id: newResCollection[newResCollection.length - 1].dataSource[index][newResCollection[newResCollection.length - 1].id] });
	                            group = newResCollection[newResCollection.length - 1].dataSource[index][newResCollection[newResCollection.length - 1].groupId];
	                        }
	                    }
	                    else {
	                        resourceData = newResCollection[i].dataSource instanceof ej.DataManager ? newResCollection[i].dataSource : ej.DataManager(newResCollection[i].dataSource);
	                        query = new ej.Query().where(newResCollection[i].id, ej.FilterOperators.equal, group);
	                        result = resourceData.executeLocal(query);
	                        this._resourceCollection.push({ id: result[0][newResCollection[i].id] });
	                        group = result[0][newResCollection[i].groupId];
	                    }
	                }
	                return this._resourceCollection;
	            }
	        }
	    },

	    _getResourceFields: function (obj) {
	        if(!ej.isNullOrUndefined(this.model.group)){
	        for (var j = 0, i = this._resourceCollection.length - 1; j < this._resourceCollection.length; j++, i--) {

	            obj[this.model.appointmentSettings.resourceFields.split(',')[j]] = this._resourceCollection[i].id;
	        }}
            else
                obj[this.model.appointmentSettings.resourceFields.split(',')[0]] = this._resourceCollection[0].id;
	        return obj;
	    },
	    _getDragDropResourceData: function (proxy, cellIndex, _newAddList) {
	        if (!ej.isNullOrUndefined(cellIndex)) {
	            var noOfCols = proxy.model.currentView === "week" || proxy.model.currentView === "month" ? 7 : proxy.model.currentView === "workweek" ? 5 : 1;
	            var newRes = proxy.model.orientation == "vertical" ? proxy.res1[Math.floor(cellIndex / noOfCols)] : proxy._resCollect[cellIndex];
	            _newAddList[proxy.model.appointmentSettings.resourceFields.split(',')[proxy.model.appointmentSettings.resourceFields.split(',').length - 1]] = newRes.id;
	            _newAddList[proxy.model.appointmentSettings.resourceFields.split(',')[proxy.model.appointmentSettings.resourceFields.split(',').length - 2]] = newRes.groupId;
	        }
	        return _newAddList;
	    },

	    _renderResourceData: function (targetElement, index) {
	        if (!ej.isNullOrUndefined(this.model.resources)) {
	            if (this.model.resources.length > 0) {
	                var noOfDays = this.model.currentView === "week" || this.model.currentView === "month" ? 7 : this.model.currentView === "workweek" ? 5 : 1;
	                index = this.model.currentView === "month" ? targetElement.index() : index;
	                index = this.model.orientation == "vertical" ? parseInt(index / noOfDays) : this._workCellIndex;
	                var res1 = this.model.orientation == "vertical" ? this.res1 : this._resCollect;
	                var group, resourceData, query, result, prevdata, resApp1, fieldCollection = []; this._resIdCollection = [];
	                var newResCollection = this._getResourceCollection();
	                for (var i = 0; i < newResCollection.length; i++) {
	                    this._appointmentAddWindow.find('.owner_' + i).ejAutocomplete("clearText");
	                }
	                this.resourceId = [];
	                for (var i = newResCollection.length - 1; i >= 0; i--) {
	                    if (i == newResCollection.length - 1) {
	                        if (!ej.isNullOrUndefined(this.model.group)) {
	                            this.resourceId.push({ id: res1[index][newResCollection[i].id], value: res1[index][newResCollection[i].text] });
	                            group = res1[index][newResCollection[i].groupId];
	                        }
	                        else {
	                            this.resourceId.push({ id: this.render_Resources[i][index][newResCollection[i].id], value: this.render_Resources[i][index][newResCollection[i].text] });
	                            group = this.render_Resources[i][index][newResCollection[i].groupId];
	                        }
	                        if (this.model.resources.length == 1)
	                            this._appointmentAddWindow.find('.owner_' + i).data("ejAutocomplete").selectValueByText(this.resourceId[0].value);
	                    }
	                    else {
	                        resourceData = newResCollection[i].dataSource instanceof ej.DataManager ? newResCollection[i].dataSource : ej.DataManager(newResCollection[i].dataSource);
	                        query = new ej.Query().where(newResCollection[i].id, ej.FilterOperators.equal, group);
	                        result = resourceData.executeLocal(query);
	                        this._appointmentAddWindow.find('.owner_' + i).data("ejAutocomplete").selectValueByText(result[0][newResCollection[i].text]);
	                        this.resourceId.push({ id: result[0][newResCollection[i].id], value: result[0][newResCollection[i].text] });
	                        group = result[0][newResCollection[i].groupId];
	                    }
	                }
	                if (this.model.resources.length > 1) {
	                    for (var j = 0, l = this.render_Resources.length - 1; j < this.render_Resources.length - 1; j++, l--) {
	                        prevdata = this.render_Resources[j + 1] instanceof ej.DataManager ? this.render_Resources[j + 1] : ej.DataManager(this.render_Resources[j + 1]);
	                        query = new ej.Query().where(newResCollection[j + 1].groupId, ej.FilterOperators.equal, this.resourceId[l][newResCollection[l].id]);
	                        resApp1 = prevdata.executeLocal(query);
	                        fieldCollection = [];
	                        for (var k = 0; k < resApp1.length; k++) {
	                            fieldCollection.push({ text: resApp1[k][newResCollection[j + 1].text], value: resApp1[k][newResCollection[j + 1].id], color: resApp1[k][newResCollection[j + 1].color] });
	                        }
	                        this._appointmentAddWindow.find('.owner_' + (j + 1)).ejAutocomplete("clearText");
	                        this._appointmentAddWindow.find('.owner_' + (j + 1)).ejAutocomplete("option", "dataSource", fieldCollection); //.data("ejAutocomplete").selectValueByKey(resApp1[0].id);

	                    }
	                    for (var j = 0, l = this.render_Resources.length - 1; j < this.render_Resources.length - 1; j++, l--) {
	                        this._appointmentAddWindow.find('.owner_' + (j + 1)).data("ejAutocomplete").selectValueByKey(this.resourceId[l - 1][newResCollection[l - 1].id]);
	                    }
	                }
	            }
	        }
	    },

	    /**
        * To configure the dataSource values of resources
        * @private
        */
	    _bindResourcesData: function () {
	        if (!ej.isNullOrUndefined(this.model.resources)) {
	            // this._levelresourceData = [], 
	            this._resourceInfo = []; var resFlag = false;
	            for (var i = 0; i < this.model.resources.length; i++) {
	                if (!ej.isNullOrUndefined(this.model.resources[i].resourceSettings)) {
	                    if (this.model.resources[i].resourceSettings.dataSource instanceof ej.DataManager)
	                        this._initResourceData(this.model.resources[i].resourceSettings, i);
	                    else {
	                        this._resourceInfo.push(this.model.resources[i].resourceSettings);
	                        resFlag = true;
	                        //this.model.resources[i].resourceSettings.dataSource
	                    }
	                }
	            }
	            if (resFlag)
	                this._renderInitSchedule();
	        }
	    },

	    _renderResourceElements: function ($appWindow) {
	        for (var i = 0; i < this.model.resources.length; i++) {
	            $appWindow += "<tr><td class='e-leftfields e-textlabel'>" + this.model.resources[i].title + ":</td><td colspan='3' class='e-rightfields'>" +
						  "<input id='" + this._id + "_ownerfield_" + i + "'  class='owner_" + i + "' type='text' value=''/><div id='ownerlist'></div></td></tr>";
	        }
	        return $appWindow;
	    },

	    _renderResourcesTemplate: function () {
	        //resource header template rendering
	        if (this.model.orientation == "vertical")
	            this.resourceHeadTemplate = $.templates(this._createTemplate(resourceHeadTemplate(), "_ResourceHeader"));

	        //resource autocomplete template rendering
	        if (!ej.isNullOrUndefined(this.model.resources))
	            this.resourceTemplate = "<div class='e-resourcediv' style='height:15px; margin-right:5px; margin-top:3px; float:left; width:15px; background-color: ${color}'></div> <div>${text}</div>";
	    }
	};
})(jQuery, Syncfusion);